Cannot remove striped object
06/09/2017 08:44 AM - Jan Kasprzak
Description

| have created a RADOS striped object using
$ dd someargs | rados --pool testpool --striper put testfile -
and interrupted it in the middle of writing. Now | cannot remove this object:

$ rados --pool testpool --striper rm testfile
error removing testpool>testfile: (16) Device or resource busy

Removing the individual parts of the striped object in the order given by "rados Is" works;

rados --pool testpool Is | grep *estfile.000 | while read filename
do

rados --pool testpool rm $filename

done

This problem has originally been discussed in ceph-users list here:
https://www.mail-archive.com/ceph-users@lists.ceph.com/msg37962.html

History

#1 - 06/09/2017 08:40 PM - Greg Farnum
- Project changed from RADQOS to Ceph

- Category set to libradosstriper

#2 - 06/15/2017 11:15 PM - Stan K

I've had simmilar issue.
It seems to be caused by not releasing the "striper.lock" on the striped object in case of the interrupt.

This lock is kept on the first rados object(usually with name <object_name>.0000000000000000). As a workaround you can do following:

### View lock on the object

~# rados -p sata lock info test_break.0000000000000000 striper.lock | python -mjson.tool

{

"lockers": [
{
"addr": "192.168.0.101:0/2836237895",
"cookie": "30dd70el-2c45-47ce-9b57-20£3531cld29",
"description": "",
"expiration": "0.000000",
"name": "client.11054303"
}
"name": "striper.lock",
"tag": "Tag",
"type": "shared"

### Break the lock by client name and cookie
~# rados -p sata lock break test_break.0000000000000000 striper.lock client.11054303 --lock-cookie 30dd70el-2c

45-47ce-9b57-20£3531c1d29
After that object is possible to delete using striper interface:

~# rados —--striper -p sata rm test_break
